| Flutter Impeller |

Public Member Functions | List of all members
impeller::SurfaceContextVK Class Reference

`#include <surface_context_vk.h>`

Inheritance diagram for impeller::SurfaceContextVK:

## Public Member Functions
| SurfaceContextVK (const std::shared_ptr< ContextVK > &parent)
| ~SurfaceContextVK () override
BackendType | GetBackendType () const override
| Get the graphics backend of an Impeller context. More...
std::string | DescribeGpuModel () const override
bool | IsValid () const override
| Determines if a context is valid. If the caller ever receives an invalid context, they must discard it and construct a new context. There is no recovery mechanism to repair a bad context. More...
std::shared_ptr< Allocator > | GetResourceAllocator () const override
| Returns the allocator used to create textures and buffers on the device. More...
std::shared_ptr< ShaderLibrary > | GetShaderLibrary () const override
| Returns the library of shaders used to specify the programmable stages of a pipeline. More...
std::shared_ptr< SamplerLibrary > | GetSamplerLibrary () const override
| Returns the library of combined image samplers used in shaders. More...
std::shared_ptr< PipelineLibrary > | GetPipelineLibrary () const override
| Returns the library of pipelines used by render or compute commands. More...
std::shared_ptr< CommandBuffer > | CreateCommandBuffer () const override
| Create a new command buffer. Command buffers can be used to encode graphics, blit, or compute commands to be submitted to the device. More...
const std::shared_ptr< const Capabilities > & | GetCapabilities () const override
| Get the capabilities of Impeller context. All optionally supported feature of the platform, client-rendering API, and device can be queried using the `Capabilities`. More...
std::shared_ptr< CommandQueue > | GetCommandQueue () const override
| Return the graphics queue for submitting command buffers. More...
void | Shutdown () override
| Force all pending asynchronous work to finish. This is achieved by deleting all owned concurrent message loops. More...
bool | SetWindowSurface (vk::UniqueSurfaceKHR surface, const ISize &size)
bool | SetSwapchain (std::shared_ptr< SwapchainVK > swapchain)
std::unique_ptr< Surface > | AcquireNextSurface ()
void | UpdateSurfaceSize (const ISize &size) const
| Mark the current swapchain configuration as dirty, forcing it to be recreated on the next frame. More...
void | InitializeCommonlyUsedShadersIfNeeded () const override
void | DisposeThreadLocalCachedResources () override
const vk::Device & | GetDevice () const
const std::shared_ptr< ContextVK > & | GetParent () const
Public Member Functions inherited from impeller::Context
virtual | ~Context ()
| Destroys an Impeller context. More...
virtual bool | UpdateOffscreenLayerPixelFormat (PixelFormat format)
virtual void | StoreTaskForGPU (const fml::closure &task, const fml::closure &failure)

## Additional Inherited Members
Public Types inherited from impeller::Context
enum | BackendType { BackendType::kMetal, BackendType::kOpenGLES, BackendType::kVulkan }
Static Public Member Functions inherited from impeller::BackendCast< SurfaceContextVK, Context >
static SurfaceContextVK & | Cast (Context &base)
static const SurfaceContextVK & | Cast (const Context &base)
static SurfaceContextVK * | Cast (Context *base)
static const SurfaceContextVK * | Cast (const Context *base)
Static Public Attributes inherited from impeller::Context
static constexpr int32_t | kMaxTasksAwaitingGPU = 10
Protected Member Functions inherited from impeller::Context
| Context ()
Protected Attributes inherited from impeller::Context
std::vector< std::function< void()> > | per_frame_task_

## Detailed Description

For Vulkan, there is both a ContextVK that implements Context and a SurfaceContextVK that also implements Context and takes a ContextVK as its parent. There is a one to many relationship between ContextVK and SurfaceContextVK.

Most operations in this class are delegated to the parent ContextVK. This class specifically manages swapchains and creation of VkSurfaces on Android. By maintaining the swapchain this way, it is possible to have multiple surfaces sharing the same ContextVK without stepping on each other's swapchains.

Definition at line 31 of file surface_context_vk.h.

## Constructor & Destructor Documentation

## ◆ SurfaceContextVK()

impeller::SurfaceContextVK::SurfaceContextVK | ( | const std::shared_ptr< ContextVK > & | parent | ) |
| explicit

Definition at line 15 of file surface_context_vk.cc.

16 : parent_(parent) {}

## ◆ ~SurfaceContextVK()

impeller::SurfaceContextVK::~SurfaceContextVK | ( |  | ) |
| overridedefault

## Member Function Documentation

## ◆ AcquireNextSurface()

std::unique_ptr< Surface > impeller::SurfaceContextVK::AcquireNextSurface | ( |  | ) |

Definition at line 79 of file surface_context_vk.cc.

79 {
80 TRACE_EVENT0("impeller", __FUNCTION__);
81 auto surface = swapchain_ ? swapchain_->AcquireNextDrawable() : nullptr;
82 if (!surface) {
83 return nullptr;
84 }
85 if (auto pipeline_library = parent_->GetPipelineLibrary()) {
86 impeller::PipelineLibraryVK::Cast(*pipeline_library)
87 .DidAcquireSurfaceFrame();
88 }
89 parent_->GetCommandPoolRecycler()->Dispose();
90 parent_->GetResourceAllocator()->DebugTraceMemoryStatistics();
91 return surface;
92 }

References impeller::BackendCast< PipelineLibraryVK, PipelineLibrary >::Cast(), and impeller::PipelineLibraryVK::DidAcquireSurfaceFrame().

## ◆ CreateCommandBuffer()

std::shared_ptr< CommandBuffer > impeller::SurfaceContextVK::CreateCommandBuffer | ( |  | ) | const
| overridevirtual

Create a new command buffer. Command buffers can be used to encode graphics, blit, or compute commands to be submitted to the device.

A command buffer can only be used on a single thread. Multi-threaded render, blit, or compute passes must create a new command buffer on each thread.

Returns
  A new command buffer.

Implements impeller::Context.

Definition at line 48 of file surface_context_vk.cc.

48 {
49 return parent_->CreateCommandBuffer();
50 }

## ◆ DescribeGpuModel()

std::string impeller::SurfaceContextVK::DescribeGpuModel | ( |  | ) | const
| overridevirtual

Implements impeller::Context.

Definition at line 24 of file surface_context_vk.cc.

24 {
25 return parent_->DescribeGpuModel();
26 }

## ◆ DisposeThreadLocalCachedResources()

void impeller::SurfaceContextVK::DisposeThreadLocalCachedResources | ( |  | ) |
| overridevirtual

Dispose resources that are cached on behalf of the current thread.

Some backends such as Vulkan may cache resources that can be reused while executing a rendering operation. This API can be called after the operation completes in order to clear the cache.

Reimplemented from impeller::Context.

Definition at line 106 of file surface_context_vk.cc.

106 {
107 parent_->DisposeThreadLocalCachedResources();
108 }

## ◆ GetBackendType()

Context::BackendType impeller::SurfaceContextVK::GetBackendType | ( |  | ) | const
| overridevirtual

Get the graphics backend of an Impeller context.

            This is useful for cases where a renderer needs to track and
            lookup backend-specific resources, like shaders or uniform
            layout information.

            It's not recommended to use this as a substitute for
            per-backend capability checking. Instead, check for specific
            capabilities via `GetCapabilities()`.

Returns
  The graphics backend of the `Context`.

Implements impeller::Context.

Definition at line 20 of file surface_context_vk.cc.

20 {
21 return parent_->GetBackendType();
22 }

## ◆ GetCapabilities()

const std::shared_ptr< const Capabilities > & impeller::SurfaceContextVK::GetCapabilities | ( |  | ) | const
| overridevirtual

Get the capabilities of Impeller context. All optionally supported feature of the platform, client-rendering API, and device can be queried using the `Capabilities`.

Returns
  The capabilities. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 56 of file surface_context_vk.cc.

57 {
58 return parent_->GetCapabilities();
59 }

## ◆ GetCommandQueue()

std::shared_ptr< CommandQueue > impeller::SurfaceContextVK::GetCommandQueue | ( |  | ) | const
| overridevirtual

Return the graphics queue for submitting command buffers.

Implements impeller::Context.

Definition at line 52 of file surface_context_vk.cc.

52 {
53 return parent_->GetCommandQueue();
54 }

## ◆ GetDevice()

const vk::Device & impeller::SurfaceContextVK::GetDevice | ( |  | ) | const

Definition at line 98 of file surface_context_vk.cc.

98 {
99 return parent_->GetDevice();
100 }

## ◆ GetParent()

const std::shared_ptr< ContextVK > & impeller::SurfaceContextVK::GetParent | ( |  | ) | const

Definition at line 110 of file surface_context_vk.cc.

110 {
111 return parent_;
112 }

Referenced by impeller::testing::TEST_P().

## ◆ GetPipelineLibrary()

std::shared_ptr< PipelineLibrary > impeller::SurfaceContextVK::GetPipelineLibrary | ( |  | ) | const
| overridevirtual

Returns the library of pipelines used by render or compute commands.

Returns
  The pipeline library. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 44 of file surface_context_vk.cc.

44 {
45 return parent_->GetPipelineLibrary();
46 }

## ◆ GetResourceAllocator()

std::shared_ptr< Allocator > impeller::SurfaceContextVK::GetResourceAllocator | ( |  | ) | const
| overridevirtual

Returns the allocator used to create textures and buffers on the device.

Returns
  The resource allocator. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 32 of file surface_context_vk.cc.

32 {
33 return parent_->GetResourceAllocator();
34 }

## ◆ GetSamplerLibrary()

std::shared_ptr< SamplerLibrary > impeller::SurfaceContextVK::GetSamplerLibrary | ( |  | ) | const
| overridevirtual

Returns the library of combined image samplers used in shaders.

Returns
  The sampler library. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 40 of file surface_context_vk.cc.

40 {
41 return parent_->GetSamplerLibrary();
42 }

## ◆ GetShaderLibrary()

std::shared_ptr< ShaderLibrary > impeller::SurfaceContextVK::GetShaderLibrary | ( |  | ) | const
| overridevirtual

Returns the library of shaders used to specify the programmable stages of a pipeline.

Returns
  The shader library. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 36 of file surface_context_vk.cc.

36 {
37 return parent_->GetShaderLibrary();
38 }

## ◆ InitializeCommonlyUsedShadersIfNeeded()

void impeller::SurfaceContextVK::InitializeCommonlyUsedShadersIfNeeded | ( |  | ) | const
| overridevirtual

Run backend specific additional setup and create common shader variants.

This bootstrap is intended to improve the performance of several first frame benchmarks that are tracked in the flutter device lab. The workload includes initializing commonly used but not default shader variants, as well as forcing driver initialization.

Reimplemented from impeller::Context.

Definition at line 102 of file surface_context_vk.cc.

102 {
103 parent_->InitializeCommonlyUsedShadersIfNeeded();
104 }

## ◆ IsValid()

bool impeller::SurfaceContextVK::IsValid | ( |  | ) | const
| overridevirtual

Determines if a context is valid. If the caller ever receives an invalid context, they must discard it and construct a new context. There is no recovery mechanism to repair a bad context.

It is convention in Impeller to never return an invalid context from a call that returns an pointer to a context. The call implementation performs validity checks itself and return a null context instead of a pointer to an invalid context.

How a context goes invalid is backend specific. It could happen due to device loss, or any other unrecoverable error.

Returns
  If the context is valid.

Implements impeller::Context.

Definition at line 28 of file surface_context_vk.cc.

28 {
29 return parent_->IsValid();
30 }

## ◆ SetSwapchain()

bool impeller::SurfaceContextVK::SetSwapchain | ( | std::shared_ptr< SwapchainVK > | swapchain | ) |

Definition at line 70 of file surface_context_vk.cc.

70 {
71 if (!swapchain || !swapchain->IsValid()) {
72 VALIDATION_LOG << "Invalid swapchain.";
73 return false;
74 }
75 swapchain_ = std::move(swapchain);
76 return true;
77 }

References VALIDATION_LOG.

Referenced by SetWindowSurface().

## ◆ SetWindowSurface()

bool impeller::SurfaceContextVK::SetWindowSurface | ( | vk::UniqueSurfaceKHR | surface,
|  | const ISize & | size
| ) |  |

Definition at line 65 of file surface_context_vk.cc.

66 {
67 return SetSwapchain(SwapchainVK::Create(parent_, std::move(surface), size));
68 }

References impeller::SwapchainVK::Create(), and SetSwapchain().

## ◆ Shutdown()

void impeller::SurfaceContextVK::Shutdown | ( |  | ) |
| overridevirtual

Force all pending asynchronous work to finish. This is achieved by deleting all owned concurrent message loops.

Implements impeller::Context.

Definition at line 61 of file surface_context_vk.cc.

61 {
62 parent_->Shutdown();
63 }

## ◆ UpdateSurfaceSize()

void impeller::SurfaceContextVK::UpdateSurfaceSize | ( | const ISize & | size | ) | const

Mark the current swapchain configuration as dirty, forcing it to be recreated on the next frame.

Definition at line 94 of file surface_context_vk.cc.

94 {
95 swapchain_->UpdateSurfaceSize(size);
96 }

The documentation for this class was generated from the following files:

- impeller/renderer/backend/vulkan/surface_context_vk.h
- impeller/renderer/backend/vulkan/surface_context_vk.cc

impeller::SurfaceContextVK::SetSwapchain
bool SetSwapchain(std::shared_ptr< SwapchainVK > swapchain)
Definition: surface_context_vk.cc:70
impeller::PipelineLibraryVK::DidAcquireSurfaceFrame
void DidAcquireSurfaceFrame()
Definition: pipeline_library_vk.cc:279
impeller::SwapchainVK::Create
static std::shared_ptr< SwapchainVK > Create(const std::shared_ptr< Context > &context, vk::UniqueSurfaceKHR surface, const ISize &size, bool enable_msaa=true)
Definition: swapchain_vk.cc:19
VALIDATION_LOG
#define VALIDATION_LOG
Definition: validation.h:91
impeller::BackendCast< PipelineLibraryVK, PipelineLibrary >::Cast
static PipelineLibraryVK & Cast(PipelineLibrary &base)
Definition: backend_cast.h:13